#include "predef.h" 
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <sim5272.h>



extern "C" { 
void UserMain(void * pd);
extern const unsigned long CPU_CLOCK;
}

const char * AppName="bare_serial";



void OpenBareSerial(int port, unsigned long baud)
{

volatile uartstruct *ThisUart = &sim.uarts[port];

unsigned char ub1 = 0;
unsigned char ub2 = 0x41;


   switch ( baud )
   {
     case 115200:
       ub2 = 17;
       break;
     case 57600:
       ub2 = 34;
       break;
     case 38400:
       ub2 = 51;
       break;
     case 28800:
       ub2 = 68;
       break;
     case 19200:
       ub2 = 102;
       break;
     case 9600:
       ub2 = 203;
       break;
     case 4800:
       ub1 = 1;
       ub2 = 151;
       break;
     case 2400:
       ub1 = 3;
       ub2 = 46;
       break;
     case 1200:
       ub1 = 6;
       ub2 = 92;
       break;
     case 600:
       ub1 = 12;
       ub2 = 183;
       break;
     case 300:
       ub1 = 25;
       ub2 = 110;
       break;
     default:
       ub2 = 17;
   }

ThisUart->ucr = 0x2a; /*Reset Rx Transmit disable Rx disable */
ThisUart->ucr = 0x3a;    /*Reset Tx Transmit disable Rx disable */
ThisUart->ucr = 0x1a;/*Transmit disable Rx disable reset mode reg */

ThisUart->ucr = 0x10;
ThisUart->umr = 0x13; /* umr1 8 data bits no parity */
ThisUart->umr = 0x27;  /* umr2 1 stop*/ 

ThisUart->usr = 0xDD; /* Use the internal timer for Baud Rate Generation */
ThisUart->uisr = 0x00;  /*Enable No interrupts */

ThisUart->ubg1 = ub1; /* Actualy set the baud rate we calculated */
ThisUart->ubg2 = ub2;


switch (port) /* Set up the hardware ports */
{
case 0:
    break;
case 1:
	sim.pdcnt &= 0xFEAB;   // 1111 1110 1010 1011
	sim.pdcnt |= 0x02A8;   // 0000 0010 1010 1000
	break;
}//End of switch


ThisUart->ucr = 0x05;/*Enable Tx and Rx */ 
}


void NoIsrWriteChar(int port, char c)
{
 while ( ( sim.uarts[port].usr & 4 ) == 0 ); 
 sim.uarts[port].udb = ( unsigned char ) c;  
}


char NoIsrGetChar(int port)
{
while ( ( sim.uarts[port].usr & 1 ) == 0 );
return sim.uarts[port].udb;
}


int NoIsrCharAvail(int port)
{
   return  ( ( sim.uarts[port].usr & 1 ) != 0 );
}








void UserMain(void * pd)
{
   InitializeStack();
   if (EthernetIP == 0) GetDHCPAddress(); 
   OSChangePrio(MAIN_PRIO);
   EnableAutoUpdate();

   OpenBareSerial(1,115200);

   iprintf("Application started\n");
   while (1)
  {
	   char c=NoIsrGetChar(1);
	   NoIsrWriteChar(1,c);

  }
}
